﻿using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace CellGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            DataCollection data = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            for (int i = 0; i < 15; i++)
            {
                data.Add(new Data(r.ToString(), "Category" + r.ToString(), "Desc" + r.ToString(), r.ToString() + "Data"));
                r = rand.Next(100);
            }

            gridGroupingControl1.DataSource = data;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
            this.gridGroupingControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro;

            List<string> list = new List<string>();
            list.Add("11111");
            list.Add("22222");
            list.Add("33333");
            this.gridGroupingControl1.TableDescriptor.Columns["CategoryID"].Appearance.AnyRecordFieldCell.CellType = GridCellTypeName.GridListControl;
            this.gridGroupingControl1.TableDescriptor.Columns["CategoryID"].Appearance.AnyRecordFieldCell.DataSource = list;

            //to prevent editing and only select options from dropdown.
            this.gridGroupingControl1.TableDescriptor.Columns["CategoryID"].Appearance.AnyRecordFieldCell.DropDownStyle = GridDropDownStyle.Exclusive;

            //Event hookup.
            this.gridGroupingControl1.TableControlCellClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);

            //to get GridListControl renderer.
            GridDropDownGridListControlCellRenderer renderer = this.gridGroupingControl1.TableControl.CellRenderers["GridListControl"] as GridDropDownGridListControlCellRenderer;
            renderer.ListControlPart.Grid.PrepareViewStyleInfo += new GridPrepareViewStyleInfoEventHandler(Grid_PrepareViewStyleInfo);

            ////to hide a column.
            //this.gridGroupingControl1.TableDescriptor.Columns["Description"].Width = 0;
            ////to hide a column.
            //this.gridGroupingControl1.TableModel.Cols.Hidden["Description"] = true;

            ////to hide a column.
            //this.gridGroupingControl1.TableDescriptor.VisibleColumns.Remove("Description");

            //to hide a column.
            GridColHidden hiddenColumn = new GridColHidden(2);
            this.gridGroupingControl1.TableModel.ColHiddenEntries.Add(hiddenColumn);
        }

        //to change GridListControl header text.
        void Grid_PrepareViewStyleInfo(object sender, GridPrepareViewStyleInfoEventArgs e)
        {
            if (e.ColIndex == 1 && e.RowIndex == 0)
                e.Style.Text = "Text";
            e.Style.Borders.All = new GridBorder(GridBorderStyle.Solid, Color.LightGray);
        }

        void gridGroupingControl1_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
        {
            GridTableCellStyleInfo style = e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
            if (style.TableCellIdentity.TableCellType== GridTableCellType.TopLeftHeaderCell)
            {
                this.gridGroupingControl1.Table.Records.SelectAll();
            }
        }

    }
}
